---
layout: home
title: Arkenv
nav_order: 1
---

<img src="{{ site.url }}{{ site.baseurl }}/arkenv_logo.png?raw=true" width="200">


Type-safe Kotlin configuration parser `by` delegates. 

Supports the most common external configuration sources, including: 
* Command line
* Environment Variables
* Properties & Spring-like profiles
* Dot env (.env) files


## 🔨 Usage
* [Basic example usage]({{site.baseurl}}guides/example)

## [✨ Features]({{site.baseurl}}features/features)
* [Command Line]({{site.baseurl}}features/command-line)
* [Environment Variables]({{site.baseurl}}features/environment-variables)
* [Properties]({{site.baseurl}}features/properties)
* [Profiles]({{site.baseurl}}features/profiles)
* [Yaml Support]({{site.baseurl}}features/yaml)
* [Validation]({{site.baseurl}}features/validation)
* [Manual Input]({{site.baseurl}}features/manual-input)
* [Placeholders]({{site.baseurl}}features/placeholders)
* [Docker Secrets]({{site.baseurl}}features/docker-secrets)
* [Dot Env Files]({{site.baseurl}}features/dot-env-files)


### 🤝 Contributing [![PRs Welcome](https://img.shields.io/badge/PRs-welcome-brightgreen.svg?style=flat-square)](http://makeapullrequest.com) 
##### Issues
This repository is hosted on Gitlab: [https://gitlab.com/apurebase/arkenv](https://gitlab.com/apurebase/arkenv). 

Please report issues and open pull requests there.

##### Slack
Find the Arkenv channel in the [official Kotlin Slack](https://kotlinlang.slack.com/messages/CGF74HD19/).

